<a id="types-aiobotocore-ds"></a>

# types-aiobotocore-ds

[![PyPI - types-aiobotocore-ds](https://img.shields.io/pypi/v/types-aiobotocore-ds.svg?color=blue)](https://pypi.org/project/types-aiobotocore-ds)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-ds.svg?color=blue)](https://pypi.org/project/types-aiobotocore-ds)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-ds?color=blue)](https://pypistats.org/packages/types-aiobotocore-ds)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.DirectoryService 2.4.2](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/ds.html#DirectoryService)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.12.2](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-ds docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ds/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-ds](#types-aiobotocore-ds)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `DirectoryService` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[ds]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[ds]'


# standalone installation
python -m pip install types-aiobotocore-ds
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-ds
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[ds]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ds]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[ds]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[ds]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[ds]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[ds]` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[ds]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[ds]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ds]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[ds]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ds]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`DirectoryServiceClient` provides annotations for
`session.create_client("ds")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_ds import DirectoryServiceClient

session = get_session()
async with session.create_client("ds") as client:
    client: DirectoryServiceClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_ds.paginator` module contains type annotations for all
paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_ds import DirectoryServiceClient
from types_aiobotocore_ds.paginator import (
    DescribeDirectoriesPaginator,
    DescribeDomainControllersPaginator,
    DescribeSharedDirectoriesPaginator,
    DescribeSnapshotsPaginator,
    DescribeTrustsPaginator,
    ListIpRoutesPaginator,
    ListLogSubscriptionsPaginator,
    ListSchemaExtensionsPaginator,
    ListTagsForResourcePaginator,
)

session = get_session()
async with session.create_client("ds") as client:
    client: DirectoryServiceClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    describe_directories_paginator: DescribeDirectoriesPaginator = client.get_paginator(
        "describe_directories"
    )
    describe_domain_controllers_paginator: DescribeDomainControllersPaginator = (
        client.get_paginator("describe_domain_controllers")
    )
    describe_shared_directories_paginator: DescribeSharedDirectoriesPaginator = (
        client.get_paginator("describe_shared_directories")
    )
    describe_snapshots_paginator: DescribeSnapshotsPaginator = client.get_paginator(
        "describe_snapshots"
    )
    describe_trusts_paginator: DescribeTrustsPaginator = client.get_paginator("describe_trusts")
    list_ip_routes_paginator: ListIpRoutesPaginator = client.get_paginator("list_ip_routes")
    list_log_subscriptions_paginator: ListLogSubscriptionsPaginator = client.get_paginator(
        "list_log_subscriptions"
    )
    list_schema_extensions_paginator: ListSchemaExtensionsPaginator = client.get_paginator(
        "list_schema_extensions"
    )
    list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator(
        "list_tags_for_resource"
    )
```

<a id="literals"></a>

### Literals

`types_aiobotocore_ds.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_ds.literals import (
    CertificateStateType,
    CertificateTypeType,
    ClientAuthenticationStatusType,
    ClientAuthenticationTypeType,
    DescribeDirectoriesPaginatorName,
    DescribeDomainControllersPaginatorName,
    DescribeSharedDirectoriesPaginatorName,
    DescribeSnapshotsPaginatorName,
    DescribeTrustsPaginatorName,
    DirectoryConfigurationStatusType,
    DirectoryEditionType,
    DirectorySizeType,
    DirectoryStageType,
    DirectoryTypeType,
    DomainControllerStatusType,
    IpRouteStatusMsgType,
    LDAPSStatusType,
    LDAPSTypeType,
    ListIpRoutesPaginatorName,
    ListLogSubscriptionsPaginatorName,
    ListSchemaExtensionsPaginatorName,
    ListTagsForResourcePaginatorName,
    RadiusAuthenticationProtocolType,
    RadiusStatusType,
    RegionTypeType,
    ReplicationScopeType,
    SchemaExtensionStatusType,
    SelectiveAuthType,
    ShareMethodType,
    ShareStatusType,
    SnapshotStatusType,
    SnapshotTypeType,
    TargetTypeType,
    TopicStatusType,
    TrustDirectionType,
    TrustStateType,
    TrustTypeType,
    DirectoryServiceServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: CertificateStateType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_ds.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_ds.type_defs import (
    AcceptSharedDirectoryRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    SharedDirectoryTypeDef,
    IpRouteTypeDef,
    DirectoryVpcSettingsTypeDef,
    TagTypeDef,
    AttributeTypeDef,
    CancelSchemaExtensionRequestRequestTypeDef,
    CertificateInfoTypeDef,
    ClientCertAuthSettingsTypeDef,
    ClientAuthenticationSettingInfoTypeDef,
    ConditionalForwarderTypeDef,
    DirectoryConnectSettingsTypeDef,
    CreateAliasRequestRequestTypeDef,
    CreateConditionalForwarderRequestRequestTypeDef,
    CreateLogSubscriptionRequestRequestTypeDef,
    CreateSnapshotRequestRequestTypeDef,
    CreateTrustRequestRequestTypeDef,
    DeleteConditionalForwarderRequestRequestTypeDef,
    DeleteDirectoryRequestRequestTypeDef,
    DeleteLogSubscriptionRequestRequestTypeDef,
    DeleteSnapshotRequestRequestTypeDef,
    DeleteTrustRequestRequestTypeDef,
    DeregisterCertificateRequestRequestTypeDef,
    DeregisterEventTopicRequestRequestTypeDef,
    DescribeCertificateRequestRequestTypeDef,
    DescribeClientAuthenticationSettingsRequestRequestTypeDef,
    DescribeConditionalForwardersRequestRequestTypeDef,
    PaginatorConfigTypeDef,
    DescribeDirectoriesRequestRequestTypeDef,
    DescribeDomainControllersRequestRequestTypeDef,
    DomainControllerTypeDef,
    DescribeEventTopicsRequestRequestTypeDef,
    EventTopicTypeDef,
    DescribeLDAPSSettingsRequestRequestTypeDef,
    LDAPSSettingInfoTypeDef,
    DescribeRegionsRequestRequestTypeDef,
    DescribeSettingsRequestRequestTypeDef,
    SettingEntryTypeDef,
    DescribeSharedDirectoriesRequestRequestTypeDef,
    DescribeSnapshotsRequestRequestTypeDef,
    SnapshotTypeDef,
    DescribeTrustsRequestRequestTypeDef,
    TrustTypeDef,
    DirectoryConnectSettingsDescriptionTypeDef,
    DirectoryVpcSettingsDescriptionTypeDef,
    RadiusSettingsTypeDef,
    RegionsInfoTypeDef,
    DirectoryLimitsTypeDef,
    DisableClientAuthenticationRequestRequestTypeDef,
    DisableLDAPSRequestRequestTypeDef,
    DisableRadiusRequestRequestTypeDef,
    DisableSsoRequestRequestTypeDef,
    EnableClientAuthenticationRequestRequestTypeDef,
    EnableLDAPSRequestRequestTypeDef,
    EnableSsoRequestRequestTypeDef,
    GetSnapshotLimitsRequestRequestTypeDef,
    SnapshotLimitsTypeDef,
    IpRouteInfoTypeDef,
    ListCertificatesRequestRequestTypeDef,
    ListIpRoutesRequestRequestTypeDef,
    ListLogSubscriptionsRequestRequestTypeDef,
    LogSubscriptionTypeDef,
    ListSchemaExtensionsRequestRequestTypeDef,
    SchemaExtensionInfoTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    RegisterEventTopicRequestRequestTypeDef,
    RejectSharedDirectoryRequestRequestTypeDef,
    RemoveIpRoutesRequestRequestTypeDef,
    RemoveRegionRequestRequestTypeDef,
    RemoveTagsFromResourceRequestRequestTypeDef,
    ResetUserPasswordRequestRequestTypeDef,
    RestoreFromSnapshotRequestRequestTypeDef,
    SettingTypeDef,
    ShareTargetTypeDef,
    StartSchemaExtensionRequestRequestTypeDef,
    UnshareTargetTypeDef,
    UpdateConditionalForwarderRequestRequestTypeDef,
    UpdateNumberOfDomainControllersRequestRequestTypeDef,
    UpdateTrustRequestRequestTypeDef,
    VerifyTrustRequestRequestTypeDef,
    ConnectDirectoryResultTypeDef,
    CreateAliasResultTypeDef,
    CreateDirectoryResultTypeDef,
    CreateMicrosoftADResultTypeDef,
    CreateSnapshotResultTypeDef,
    CreateTrustResultTypeDef,
    DeleteDirectoryResultTypeDef,
    DeleteSnapshotResultTypeDef,
    DeleteTrustResultTypeDef,
    RegisterCertificateResultTypeDef,
    RejectSharedDirectoryResultTypeDef,
    ShareDirectoryResultTypeDef,
    StartSchemaExtensionResultTypeDef,
    UnshareDirectoryResultTypeDef,
    UpdateSettingsResultTypeDef,
    UpdateTrustResultTypeDef,
    VerifyTrustResultTypeDef,
    AcceptSharedDirectoryResultTypeDef,
    DescribeSharedDirectoriesResultTypeDef,
    AddIpRoutesRequestRequestTypeDef,
    AddRegionRequestRequestTypeDef,
    RegionDescriptionTypeDef,
    AddTagsToResourceRequestRequestTypeDef,
    CreateDirectoryRequestRequestTypeDef,
    CreateMicrosoftADRequestRequestTypeDef,
    ListTagsForResourceResultTypeDef,
    ComputerTypeDef,
    CreateComputerRequestRequestTypeDef,
    ListCertificatesResultTypeDef,
    CertificateTypeDef,
    RegisterCertificateRequestRequestTypeDef,
    DescribeClientAuthenticationSettingsResultTypeDef,
    DescribeConditionalForwardersResultTypeDef,
    ConnectDirectoryRequestRequestTypeDef,
    DescribeDirectoriesRequestDescribeDirectoriesPaginateTypeDef,
    DescribeDomainControllersRequestDescribeDomainControllersPaginateTypeDef,
    DescribeSharedDirectoriesRequestDescribeSharedDirectoriesPaginateTypeDef,
    DescribeSnapshotsRequestDescribeSnapshotsPaginateTypeDef,
    DescribeTrustsRequestDescribeTrustsPaginateTypeDef,
    ListIpRoutesRequestListIpRoutesPaginateTypeDef,
    ListLogSubscriptionsRequestListLogSubscriptionsPaginateTypeDef,
    ListSchemaExtensionsRequestListSchemaExtensionsPaginateTypeDef,
    ListTagsForResourceRequestListTagsForResourcePaginateTypeDef,
    DescribeDomainControllersResultTypeDef,
    DescribeEventTopicsResultTypeDef,
    DescribeLDAPSSettingsResultTypeDef,
    DescribeSettingsResultTypeDef,
    DescribeSnapshotsResultTypeDef,
    DescribeTrustsResultTypeDef,
    EnableRadiusRequestRequestTypeDef,
    OwnerDirectoryDescriptionTypeDef,
    UpdateRadiusRequestRequestTypeDef,
    GetDirectoryLimitsResultTypeDef,
    GetSnapshotLimitsResultTypeDef,
    ListIpRoutesResultTypeDef,
    ListLogSubscriptionsResultTypeDef,
    ListSchemaExtensionsResultTypeDef,
    UpdateSettingsRequestRequestTypeDef,
    ShareDirectoryRequestRequestTypeDef,
    UnshareDirectoryRequestRequestTypeDef,
    DescribeRegionsResultTypeDef,
    CreateComputerResultTypeDef,
    DescribeCertificateResultTypeDef,
    DirectoryDescriptionTypeDef,
    DescribeDirectoriesResultTypeDef,
)


def get_structure() -> AcceptSharedDirectoryRequestRequestTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-ds` version is the same as related `aiobotocore` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ds/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
